package io.openems.edge.ess.byd.container;

import org.osgi.service.metatype.annotations.AttributeDefinition;
import org.osgi.service.metatype.annotations.ObjectClassDefinition;

@ObjectClassDefinition(//
		name = "ESS FENECON BYD Container", //
		description = "Implements the FENECON BYD Container")
public @interface Config {

	@AttributeDefinition(name = "Component-ID", description = "Unique ID of this Component")
	String id() default "ess0";

	@AttributeDefinition(name = "Alias", description = "Human-readable name of this Component; defaults to Component-ID")
	String alias() default "";

	@AttributeDefinition(name = "Is enabled?", description = "Is this Component enabled?")
	boolean enabled() default true;

	@AttributeDefinition(name = "Read-Only mode", description = "Enables Read-Only mode")
	boolean readonly() default false;

	@AttributeDefinition(name = "Modbus-ID 0 (PCS + BECU)", description = "ID of Modbus bridge to PCS and BECU.")
	String modbus_id0();

	@AttributeDefinition(name = "Modbus-ID 1 (ADAS)", description = "ID of Modbus bridge to ADAS.")
	String modbus_id1();

	@AttributeDefinition(name = "Modbus-ID 2 (RTU)", description = "ID of Modbus bridge to RTU.")
	String modbus_id2();

	@AttributeDefinition(name = "Modbus0 target filter", description = "This is auto-generated by 'Modbus-ID 0'.")
	String Modbus_target() default "(enabled=true)";

	@AttributeDefinition(name = "Modbus1 target filter", description = "This is auto-generated by 'Modbus-ID 1'.")
	String modbus1_target() default "(enabled=true)";

	@AttributeDefinition(name = "Modbus2 target filter", description = "This is auto-generated by 'Modbus-ID 2'.")
	String modbus2_target() default "(enabled=true)";

	String webconsole_configurationFactory_nameHint() default "ESS FENECON BYD Container [{id}]";
}
