package io.openems.common.websocket;

import java.util.Optional;

import org.junit.Assert;
import org.junit.Test;

import com.google.gson.JsonObject;

import io.openems.common.utils.JsonUtils;

public class OnOpenTest {

	private static JsonObject createJsonObject(String key, String value) {
		return JsonUtils.buildJsonObject() //
				.addProperty(key, value) //
				.build();
	}

	@Test
	public void testGetFieldFromHandshakeCookie() {
		Assert.assertEquals(Optional.of("bar"), //
				OnOpen.getFieldFromHandshakeCookie(//
						OnOpenTest.createJsonObject("cookie", "foo=bar"), //
						"foo"));

		Assert.assertEquals(Optional.of("bar"), //
				OnOpen.getFieldFromHandshakeCookie(//
						OnOpenTest.createJsonObject("COOKIE", "foo=bar"), //
						"foo"));

		Assert.assertEquals(Optional.of("bar"), //
				OnOpen.getFieldFromHandshakeCookie(//
						OnOpenTest.createJsonObject("cOOkIe", "foo=bar"), //
						"foo"));

		Assert.assertEquals(Optional.empty(), //
				OnOpen.getFieldFromHandshakeCookie(//
						OnOpenTest.createJsonObject("spooky", "foo=bar"), //
						"foo"));

		Assert.assertEquals(Optional.empty(), //
				OnOpen.getFieldFromHandshakeCookie(//
						OnOpenTest.createJsonObject("cookie", "foobar"), //
						"foo"));

		Assert.assertEquals(Optional.empty(), //
				OnOpen.getFieldFromHandshakeCookie(//
						OnOpenTest.createJsonObject("cookie", "foo=bar"), //
						"bar"));

		Assert.assertEquals(Optional.empty(), //
				OnOpen.getFieldFromHandshakeCookie(//
						JsonUtils.buildJsonObject().add("cookie", new JsonObject()).build(), //
						"bar"));
	}

}
